d("customSubscriptionView",['ccrz', 'util', 'customSubscriptionModel'], function(CCRZ, UTIL, customSubscriptionModel) {

    return {
        extendcustomSubscriptionView: function() {
            let customSubscModel = new customSubscriptionModel();
            CCRZ.custom = _.extend(CCRZ.custom||{}); 
            CCRZ.custom.views = _.extend(CCRZ.custom.views||{}); 
            CCRZ.custom.models = _.extend(CCRZ.custom.models||{}); 
            CCRZ.views.customSubscriptionView = CCRZ.CloudCrazeView.extend({
                el: CCRZ.uiProperties.customSubscriptionView.desktop.selector,
                viewName: "customSubscriptionView",
                subscriptionTemplate: CCRZ.util.template(CCRZ.uiProperties.customSubscriptionView.desktop.tmpl),
                init: function(){
                    let v = this;
                    CCRZ.remoteModel.getSubscriptions(JSON.stringify({}),function(res,event){
                        if(res && res.data  ){
                            v.sortSubsc(v, res);
                        }
                    });
                },
                render: function(isModal, subscId){
                    let _this = this, isFilter = this.model.get("isFilter");
                    if(!_.isEmpty(CCRZ.myaccountView.subViewArray) && (_.isUndefined(isFilter) || (!_.isUndefined(isFilter) && !isFilter)) && (_.isUndefined(isModal) || (!_.isUndefined(isModal) && !isModal)) 
                    && CCRZ.myaccountView.subViewArray[CCRZ.myaccountView.currIndex].title == 'My Downloads'){
                        if(!_.isUndefined(CCRZ.subscBackUpModel)){
                            _this.model = CCRZ.subscBackUpModel;
                            CCRZ.customSubscriptionView.model = _this.model;
                        }
                        //CCRZ.customSubscriptionView.model.set('isInit', false);
                    }
                    this.$el.html(this.subscriptionTemplate(_this.model.toJSON()));
                    if(!_.isUndefined(isModal) && isModal){
                        $('.modal-backdrop.in').remove();
                        $('#downloadAll' + subscId).modal({backdrop: true, show: true}); 
                        $('#downloadAll' + subscId).removeClass('fade');
                        $('.modal-backdrop').removeClass('fade');
                    }
                    runDefaultJsFunctions();
                    setTimeout(() => {
                        UTIL.hideLoader();
                    }, 100);
                },
                events: {
                    "click #active": "filterSubscription",
                    "click #inactive": "filterSubscription",
                    "click .closeModal": "closeModal",
                    "click .fetchAllData": "handlefetchAllData",
                    "click .downloadSingle": "handleDownloadSingle",
                    "click .downloadSelected": "handleDownloadAllData",
                    "click .downloadAllSubsc": "handleDownloadAllData",
                    'click .requestForRenew': 'handleRequestForRenewOpen',
                    'click .createLead' : 'handleRequestForRenew',
                    'click .downloadPreferenceAll' : 'handleOpenPreference',
                    'click .saveAccountPreference' : 'openPreferenceModal',
                    'click .saveAccountPref' : 'handleSaveAccount',
                    'click .saveChildPreference' : 'handleSaveSubsc',
                    'change .colorChildFilter' : 'handleChildFilter',
                    'change .layoutChildFilter' : 'handleChildFilter',
                    'change .imageChildFilter' : 'handleChildFilter',
                    'change #addAllItems' : 'handleAllItemsCheck',
                    'change .checkItem' : 'handleCheckItem',
                    'change #filterSwitch' : 'handleToggleFilter'
                },
                openPreferenceModal: function(event){
                    event.preventDefault();
                    $('#preferenceModal').modal({backdrop: true, show: true}); 
                    $('#preferenceModal').removeClass('fade');
                    $('.modal-backdrop').removeClass('fade');
                },
                handleToggleFilter: function(){
                    let _this = this, check = event.target.checked, subscId = event.target.dataset.sfid, downloadItems = _this.model.get('downloadListOriginal');
                    _this.model.set('enableFilter', check);
                    if(check){
                        _this.filterDownloadableItems(_this, subscId);
                    } else {
                        let allItemsCheck = _this.model.get('allItemsCheck');
                        downloadItems.forEach(function(dItem){
                            dItem.checked = allItemsCheck;
                        });
                        _this.model.set('downloadList', downloadItems);
                        _this.render(true, subscId);
                    }
                },
                handleCheckItem: function(){
                    let _this = this, check = event.target.checked, cImageId = event.target.dataset.id, subscId = event.target.dataset.sfid
                    , downloadList = _this.model.get('downloadList');
                    downloadList.forEach(function(item){
                        if(cImageId == item.CIMAGEID){
                            item.checked = check;
                        }
                    });
                    if(!check){
                        _this.model.set('allItemsCheck', false);
                        $('#downloadAll' + subscId + ' #addAllItems').prop('checked', false);
                    }
                    _this.model.get('downloadList', downloadList);
                },
                handleAllItemsCheck: function(){
                    let _this = this, check = event.target.checked, subscId = event.target.dataset.sfid
                    , downloadList = _this.model.get('downloadList');
                    downloadList.forEach(function(item){
                        item.checked = check;
                    });
                    _this.model.get('downloadList', downloadList);
                    _this.model.set('allItemsCheck', check);
                    _this.render(true, subscId);
                },
                handleConvertUrlToBinary: function(){
                    debugger;
                    
                },
                handleChildFilter: function(event){
                    let _this = this, type = event.target.dataset.type, value = event.target.value
                    , subscId = event.target.dataset.sfid;
                    _this.model.set((type == 'color'?'selectedColor':(type == 'lang'?'selectedLang':(type == 'layout'?'selectedLayout':'selectedImage'))), value);
                    _this.model.set('allItemsCheck', true);
                    if(type != 'image'){
                        _this.filterDownloadableItems(_this, subscId);
                    }
                    
                },
                handleSaveAccount : function(event){
                    let v = this, isAll = event.target.dataset.isall, reqData = {
                        'imageType' : $('.imageParentFilter').val(),
                        'colorType' : $('.colorParentFilter').val(),
                        'layoutType' : $('.layoutParentFilter').val(),
                        'saveSubsc' : (isAll == 'true')?true:false
                    };
                    UTIL.showLoader();
                    customSubscModel.saveAccount(JSON.stringify(reqData),function(res,event){
                        if(res && res.data){
                            v.model.set('accountData', res.data);
                            if(isAll == 'true'){
                                let filterSubscriptionList = v.model.get('filterSubscriptionList')
                                , subscriptionList = v.model.get('subscriptionList');
                                subscriptionList.forEach(function(subsc){
                                    subsc.preferenceColor = $('.colorParentFilter').val();
                                    subsc.preferenceImage = $('.imageParentFilter').val();
                                    subsc.preferenceLayout = $('.layoutParentFilter').val();
                                });
                                filterSubscriptionList.forEach(function(subsc){
                                    subsc.preferenceColor = $('.colorParentFilter').val();
                                    subsc.preferenceImage = $('.imageParentFilter').val();
                                    subsc.preferenceLayout = $('.layoutParentFilter').val();
                                });
                                v.model.set('subscriptionList', subscriptionList);
                                v.model.set('filterSubscriptionList', filterSubscriptionList);
                            }
                            v.render();
                        } else {
                            UTIL.hideLoader();
                        }
                        $('#preferenceModal').removeClass('in show');
                        $('.modal-backdrop').css("display", "none");
                        $('.modal-backdrop').removeClass('show');
                        $('.cc_main_body').removeClass('modal-open');
                        $('.cc_main_body').css("padding-right", "0px")
                        $('.cc_main_body').css('overflow','scroll');
                    });
                },
                handleSaveSubsc : function(event){
                    let v = this, subscId = event.target.dataset.sfid, reqData = {
                        'imageType' : v.model.get('selectedImage'),
                        'colorType' : v.model.get('selectedColor'),
                        'layoutType' : v.model.get('selectedLayout'),
                        'subscId' : subscId
                    };
                    UTIL.showLoader();
                    customSubscModel.saveSubscPreferences(JSON.stringify(reqData),function(res,event){
                        if(res && res.data){
                            let filterSubscriptionList = v.model.get('filterSubscriptionList')
                            , subscriptionList = v.model.get('subscriptionList');
                            subscriptionList.forEach(function(subsc){
                                if(subsc.sfid == subscId){
                                    subsc.preferenceColor = v.model.get('selectedColor');
                                    subsc.preferenceImage = v.model.get('selectedImage');
                                    subsc.preferenceLayout = v.model.get('selectedLayout');
                                }
                            });
                            filterSubscriptionList.forEach(function(subsc){
                                if(subsc.sfid == subscId){
                                    subsc.preferenceColor = v.model.get('selectedColor');
                                    subsc.preferenceImage = v.model.get('selectedImage');
                                    subsc.preferenceLayout = v.model.get('selectedLayout');
                                }
                            });
                            v.model.set('subscriptionList', subscriptionList);
                            v.model.set('filterSubscriptionList', filterSubscriptionList);
                        } else if(res.success && !res.data){
                            CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', ("messaging-preferenceModal-Info" + subscId), CCRZ.processPageLabelMap('KFB2B_mySubsc_adminError').toString()));
                            setTimeout(function(){
                                $(".messaging-preferenceModal-Info" + subscId).css('display', 'none');
                            }, 3000);
                        } else {
                            // Error Handling
                        }
                        UTIL.hideLoader();
                    });
                },
                handleOpenPreference : function(event){
                    $('.preferenceContainer').toggleClass('hide');
                },
                handleRequestForRenew: function(event){
                    if(($('#requestForRenew' + event.target.dataset.id + ' .acc_subject').val()).trim() != '' && ($('#requestForRenew' + event.target.dataset.id + ' .acc_description').val()).trim() != ''){
                        UTIL.showLoader();
                        let reqData = {
                            'type' : 'RFR',
                            'subject' : $('#requestForRenew' + event.target.dataset.id + ' .acc_subject').val(),
                            'description' : $('#requestForRenew' + event.target.dataset.id + ' .acc_description').val(),
                            'product' : $('.createLead').data('product')
                        };
                        CCRZ.remoteModel.createLead(JSON.stringify(reqData), function(res, evt){
                            if(res && res.success && res.data){
                                CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('INFO', "messagingSection-accModal-Info", CCRZ.processPageLabelMap('KFB2B_mySubsc_notifiedInfo').toString()));
                                setTimeout(function(){
                                    $('.messagingSection-accModal-Info').css('display', 'none');
                                    $('.acc_subject').val('');
                                    $('.acc_description').val('');
                                    $('.close').click();
                                }, 3000);
                            } else {
                                // Error Handling
                                CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-accModal-Error", CCRZ.processPageLabelMap('KFB2B_mySubsc_adminError').toString()));
                                setTimeout(function(){
                                    $('.messagingSection-accModal-Error').css('display', 'none');
                                }, 3000);
                            }
                            UTIL.hideLoader();
                        });
                    } else {
                        CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-accModal-Error", CCRZ.processPageLabelMap('KFB2B_mySubsc_allReqError').toString()));
                        setTimeout(function(){
                            $('.messagingSection-accModal-Error').css('display', 'none');
                        }, 3000);
                    }
                },
                handleRequestForRenewOpen: function(event){
                    event.preventDefault();
                    $('#requestForRenew' + event.target.dataset.sfid).modal({backdrop: true, show: true}); 
                    $('#requestForRenew' + event.target.dataset.sfid).removeClass('fade');
                    $('.modal-backdrop').removeClass('fade');
                    $('.rfrProdName').html(event.target.dataset.name);
                    $('.createLead').data('product', event.target.dataset.name);
                },
                handleDownloadSingle: function(event){
                    event.preventDefault();
                    let _this = this, reprintId = event.target.dataset.id, family = event.target.dataset.id
                    , sfid = event.target.dataset.sfid, fileName = event.target.dataset.file, index = event.target.dataset.index;
                    let reqData = {
                        'reprintId' : reprintId,
                        'isDefault' : (family == 'Comics' || family == 'Political Cartoons'),
                        'type' : _this.model.attributes.selectedImage
                    }
                    let downloadItems = _this.model.get('downloadList');
                    UTIL.showLoader();
                    if(downloadItems.length > 0){
                        let downloadObj = downloadItems[index];
                        let imageType = '', fileType = '', fileName = downloadObj.name.trim() + '-' + downloadObj.PUBDATE.trim() + ((!_.isUndefined(downloadObj.UD_C32_1) && downloadObj.UD_C32_1 != '')?'-' + downloadObj.UD_C32_1.replace(' ', '').trim():'')
                        + ((!_.isUndefined(downloadObj.UD_C32_2) && downloadObj.UD_C32_2 != '')?'-' + downloadObj.UD_C32_2.replace(' ', '').trim():'') + ((!_.isUndefined(downloadObj.PAGE) && downloadObj.PAGE != '')?'-' + downloadObj.PAGE.replace(' ', '').trim():'');
                        if(_.isUndefined(_this.model.attributes.selectedImage) || downloadObj.FILE_EXT.trim() != 'TIF'){
                            imageType = downloadObj.FILE_EXT.trim().toLowerCase();
                        } else if(!_.isUndefined(_this.model.attributes.selectedImage) || downloadObj.FILE_EXT.trim() == 'TIF'){
                            imageType = _this.model.attributes.selectedImage.toLowerCase();
                        }
                        fileName = fileName + '.' + imageType;
                        if(imageType == 'pdf'){
                            fileType = 'application/pdf';
                        } else if(imageType == 'zip'){
                            fileType = 'application/zip';
                        } else if(imageType == 'tif'){
                            fileType = 'image/tiff';
                        } else if(imageType == 'jpg'){
                            fileType = 'image/jpeg';
                        }
                        reqData['originalType'] = imageType;
                        CCRZ.remoteModel.getDownloadFile(JSON.stringify(reqData), function(response, event){
                            if(response && response.success && response.data){
                                //window.open(response.data, '_blank');
                                if(imageType == 'zip'){
                                    window.open(response.data, '_blank');
                                } else {
                                    let URL = 'data:' + fileType + ';base64,' + response.data;
                                    var downloadLink = document.createElement("a");
                                    downloadLink.href = URL;
                                    downloadLink.target = '_blank';
                                    downloadLink.download = fileName;
                                    document.body.appendChild(downloadLink);
                                    downloadLink.click();
                                    document.body.removeChild(downloadLink);
                                    UTIL.hideLoader();
                                }
                            } else {
                                // Error Handling
                                CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-Modal-Info" + sfid, CCRZ.processPageLabelMap('KFB2B_mySubsc_noFileError').toString()));
                                $('#downloadAll' + sfid + ' .modal-body').animate({
                                    'scrollTop' : $('.messagingSection-Modal-Info' + sfid).position().top
                                });
                                setTimeout(function(){
                                    $('.messagingSection-Modal-Info' + sfid).css('display', 'none');
                                }, 4000);
                            }
                            UTIL.hideLoader();
                        });
                    }
                },
                filterDownloadableItems : function(_this, subscId){
                    let downloadItems = _this.model.get('downloadListOriginal').filter(function(item){
                        return item.CATEGOR215 == _this.model.get('selectedLang') && (item.UD_C32_1 == _this.model.get('selectedLayout') || (_this.model.get('selectedColor') == 'N/A' && _.isUndefined(item.UD_C32_2)))
                        && (item.UD_C32_2 == _this.model.get('selectedColor') || (_this.model.get('selectedColor') == 'N/A' && _.isUndefined(item.UD_C32_2)));
                    });
                    downloadItems = _.isUndefined(downloadItems)?[]:downloadItems;
                    if(downloadItems.length > 0){
                        downloadItems = _(downloadItems).chain().sortBy(function(download) {
                            return download['COBJECT205'];
                        }).reverse().sortBy(function(download) {
                            return download['PUBDATE'];
                        }).value().reverse();
                    }
                    let allItemsCheck = _this.model.get('allItemsCheck');
                    downloadItems.forEach(function(dItem){
                        dItem.checked = allItemsCheck;
                    });
                    _this.model.set('downloadList', downloadItems);
                    _this.render(true, subscId);
                },
                handlefetchAllData: function(event){
                    let _this = this, subscId = event.target.dataset.sfid, productId = event.target.dataset.id
                    , type = event.target.dataset.type, prodId = event.target.dataset.id, family = event.target.dataset.family
                    , accountNumber = event.target.dataset.accnum;
                    event.preventDefault();
                    _this.model.set('downloadList', []);
                    _this.model.set('downloadListOriginal', []);
                    if(CCRZ.pagevars.isNonAccredited || (!CCRZ.pagevars.isNonAccredited && CCRZ.pagevars.isCredit)){
                        let reqData = {
                            'reprintId': productId,
                            'type': 'download',
                            'productType': event.target.dataset.type,
                            'productSKU': event.target.dataset.sku,
                            'pubDate': (event.target.dataset.type == 'Reprint')?event.target.dataset.pubdate:'',
                            'UD_C64_1' : '1.0 Approved for Publication',
                            'sortType': '-pubdate',
                            'offset': '0',
                            'pageSize': '900',
                            'isPDP' : false
                        };
                        if(family == 'Production Services'){
                            reqData['accountNumber'] = accountNumber;
                        }
                        UTIL.showLoader();
                        CCRZ.remoteModel.merlinOneSearch(JSON.stringify(reqData), function(response, event){
                            if(response && response.data && response.data.products && response.data.products.length > 0){
                                let downloadList = [], layoutSet = new Set(), colorSet = new Set(), langSet = new Set();
                                
                                let selectedSubsc = _this.model.get('filterSubscriptionList').filter(function(subsc){
                                    return subsc.sfid == subscId;
                                });
                                for(let i = 0; i < response.data.products.length;i++){
                                    let isTrue = false, reprintData = response.data.products[i];
                                    if(type == 'Reprint'){ //&& (reprintData['CIMAGEID'] == prodId || reprintData['UD_C32_1'] == 'Vertical (v)')){
                                        isTrue = true;
                                    } else if(type != 'Reprint') {
                                        isTrue = true
                                    }
                                    if(!_.isUndefined(reprintData['CATEGOR215'])){
                                        langSet.add(reprintData['CATEGOR215']);
                                    }
                                    if(!_.isUndefined(reprintData['UD_C32_2'])){
                                        colorSet.add(reprintData['UD_C32_2']);
                                    } else {
                                        colorSet.add('N/A');
                                    }
                                    if(!_.isUndefined(reprintData['UD_C32_1'])){
                                        layoutSet.add(reprintData['UD_C32_1']);
                                    } else {
                                        colorSet.add('N/A');
                                    }
                                    if(isTrue){
                                        for(let key in reprintData){
                                            if(key == 'THUMBWEB'){
                                                reprintData['mediaURI'] = UTIL.parseImage(reprintData[key]);
                                            } else if(key == 'THUMB512'){
                                                reprintData['media512URI'] = UTIL.parseImage(reprintData[key]);
                                            } else if(key == 'HIRES'){
                                                //reprintData['mediaHDURI'] = UTIL.parseImage(reprintData[key]);
                                            } else if(key == 'PUBDATE'){
                                                reprintData['PUBDATE'] = UTIL.formatDate(new Date(reprintData[key]), 'mm/dd/yyyy');
                                            } else if(key == 'CSERVICE13'){
                                                reprintData['name'] = (reprintData[key]).trim();
                                            }  else if(key == 'COBJECT205'){
                                                let file = (reprintData[key]).trim(), fileList = file.split('-')
                                                , fileName = reprintData['FILE_EXT'];
                                                reprintData['fileName'] = fileName.toLowerCase().trim();
                                            } else if(key == 'PAGE'){
                                                reprintData[key] = (reprintData[key]).trim();
                                            }
                                        }
                                        reprintData['checked'] = true;
                                        downloadList.push(reprintData);
                                    }
                                }
                                if(downloadList.length > 0){
                                    downloadList = _(downloadList).chain().sortBy(function(download) {
                                        return download['COBJECT205'];
                                    }).reverse().sortBy(function(download) {
                                        return download['PUBDATE'];
                                    }).value().reverse();
                                    /*downloadList = _.sortBy(downloadList, function(download) { 
                                        return download['PUBDATE'];  
                                    });*/
                                    _this.model.set('downloadListOriginal', downloadList);
                                    if(type == 'Reprint'){
                                        _this.model.set('allItemsCheck', true);
                                        _this.model.set('downloadList', downloadList);
                                        _this.render(true, subscId);
                                    } else {
                                        let isAvailablePreferencce = true;
                                        _this.model.set('allItemsCheck', true);
                                        if(family == 'Comics' || family == 'Political Cartoons'){
                                            _this.model.set('langChildList', Array.from(langSet));
                                            _this.model.set('colorChildList', Array.from(colorSet));
                                            _this.model.set('layoutChildList', Array.from(layoutSet));
                                            if(!_.isUndefined(selectedSubsc[0].preferenceColor) 
                                                && _this.model.get('colorChildList').indexOf(selectedSubsc[0].preferenceColor) > 0){
                                                    _this.model.set('selectedColor', selectedSubsc[0].preferenceColor);
                                            } else {
                                                isAvailablePreferencce = true;
                                                _this.model.set('selectedColor', _this.model.get('colorChildList')[0]);
                                            }
                                            if(!_.isUndefined(selectedSubsc[0].preferenceLayout) 
                                                && _this.model.get('layoutChildList').indexOf(selectedSubsc[0].preferenceLayout) > 0){
                                                    _this.model.set('selectedLayout', selectedSubsc[0].preferenceLayout);
                                            } else {
                                                isAvailablePreferencce = true;
                                                _this.model.set('selectedLayout', _this.model.get('layoutChildList')[0]);
                                            }
                                            if(!_.isUndefined(selectedSubsc[0].preferenceLang) 
                                                && _this.model.get('langChildList').indexOf(selectedSubsc[0].preferenceLang) > 0){
                                                    _this.model.set('selectedLang', selectedSubsc[0].preferenceLang);
                                            } else {
                                                isAvailablePreferencce = true;
                                                _this.model.set('selectedLang',  _this.model.get('langChildList')[0]);
                                            }
                                            if(!_.isUndefined(selectedSubsc[0].preferenceImage) 
                                                && _this.model.get('imageList').indexOf(selectedSubsc[0].preferenceImage) > 0){
                                                    _this.model.set('selectedImage', selectedSubsc[0].preferenceImage);
                                            } else {
                                                isAvailablePreferencce = true;
                                                _this.model.set('selectedImage',  _this.model.get('imageList')[0]);
                                            }
                                            _this.model.set('showFilter', true);
                                            _this.model.set('enableFilter', true);
                                            _this.filterDownloadableItems(_this, subscId);
                                        } else {
                                            _this.model.set('showFilter', false);
                                            _this.model.set('downloadList', downloadList);
                                            _this.render(true, subscId);
                                        }
                                    }
                                } else {
                                    CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-subsc-Error", CCRZ.processPageLabelMap('KFB2B_mySubsc_noStripsError').toString()));
                                    window.scroll(0,0);
                                    setTimeout(function(){
                                        $('.messagingSection-subsc-Error').css('display', 'none');
                                    }, 4000);
                                }
                                UTIL.hideLoader();
                            } else {
                                _this.model.set('showFilter', false);
                                _this.model.set('downloadList', []);
                                _this.render(true, subscId);
                                // Error Handling
                            }
                        });
                    } else {
                        CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-subsc-Error", CCRZ.processPageLabelMap('KFB2B_mySubsc_couldNotDownload').toString()));
                        window.scroll(0,0);
                        setTimeout(function(){
                            $('.messagingSection-subsc-Error').css('display', 'none');
                        }, 4000);
                        UTIL.hideLoader();
                    }
                },
                handleDownloadAllData: function(event){
                    let subscId = event.target.dataset.sfid, name = event.target.dataset.name, products = []
                    , _this = this, action = event.target.dataset.action;
                    if(CCRZ.pagevars.isNonAccredited || (!CCRZ.pagevars.isNonAccredited && CCRZ.pagevars.isCredit)){
                        _this.model.attributes.subscriptionList.forEach(function(subscription){
                            let isTrue = false, imageList = [], layout = '', type = '', color = '';
                            if(action == 'downloadAll'){
                                if(subscription.productSptType != 'Reprint' && subscription.status == 'Active'){
                                    isTrue = true;
                                    layout = _this.model.attributes.accountData.KFB2B_Layout_Preference__c;
                                    color = _this.model.attributes.accountData.KFB2B_Color_Preference__c;
                                    type = _this.model.attributes.accountData.KFB2B_File_Preference__c;
                                }
                            } else {
                                if(subscId == subscription.sfid){
                                    let downloadList = _this.model.get('downloadList');
                                    downloadList.forEach(function(item){
                                        if(item.checked){
                                            let fileName = item.name.trim() + '-' + item.PUBDATE.trim() + ((!_.isUndefined(item.UD_C32_1) && item.UD_C32_1 != '')?'-' + item.UD_C32_1.replace(' ', '').trim():'')
                                            + ((!_.isUndefined(item.UD_C32_2) && item.UD_C32_2 != '')?'-' + item.UD_C32_2.replace(' ', '').trim():'') + ((!_.isUndefined(item.PAGE) && item.PAGE != '')?'-' + item.PAGE.replace(' ', '').trim():'');
                                            imageList.push({
                                                'fileName' : fileName,
                                                'CIMAGEID' : String(item.CIMAGEID).trim(),
                                                'fileExt' : String(item.FILE_EXT).trim()
                                            });
                                        }
                                    });
                                    layout = _this.model.get('selectedLayout');
                                    color = _this.model.get('selectedColor');
                                    type = _this.model.get('selectedImage');
                                    isTrue = true;
                                }
                            }
                            if(isTrue){
                                if(subscription.status == 'Active'){
                                    if(imageList.length > 0 || (action == 'downloadAll' && subscription.productFamily != 'Production Services')){
                                        products.push({
                                            'isReprint' : (subscription.productSptType == 'Reprint')?true:false,
                                            'productName' : subscription.productName,
                                            'productSKU' : subscription.productSKU,
                                            'pubDate' : subscription.pubDateFormat,
                                            'layout' : (action == 'downloadAll')?!_.isUndefined(subscription.preferenceLayout)?subscription.preferenceLayout:layout:layout,
                                            'color' : (action == 'downloadAll')?!_.isUndefined(subscription.preferenceColor)?subscription.preferenceColor:color:color,
                                            'type' : (action == 'downloadAll')?!_.isUndefined(subscription.preferenceImage)?subscription.preferenceImage:type:type,
                                            'f_UD_C64_1' : '1.0 Approved for Publication',
                                            'selectedItems' : imageList
                                        });
                                    }
                                }
                            }
                        });
                        if(products.length > 0){
                            let reqData = {
                                'products' : products
                            }
                            UTIL.showLoader();
                            CCRZ.remoteModel.downloadAllFiles(JSON.stringify(reqData), function(response, event){
                                if(response && response.success){
                                    let container = (action == 'downloadAll')?'messagingSection-subsc-Info':"messagingSection-Modal-Info" + subscId;
                                    CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('INFO', container, CCRZ.processPageLabelMap('KFB2B_mySubsc_emailSuccess').toString()));
                                    window.scroll(0,0);
                                    setTimeout(() => {
                                        $('.' + container).css('display', 'none');
                                    }, 5000);
                                    UTIL.hideLoader();
                                }
                            });
                        } else {
                            let container = (action == 'downloadAll')?'messagingSection-subsc-Info':"messagingSection-Modal-Info" + subscId;
                                    CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', container, (action == 'downloadAll')?CCRZ.processPageLabelMap('KFB2B_mySubsc_onlySubscError').toString():CCRZ.processPageLabelMap('KFB2B_mySubsc_minOneFileError').toString()));
                                    window.scroll(0,0);
                            setTimeout(() => {
                                $('.' + container).css('display', 'none');
                            }, 5000);
                            UTIL.hideLoader();
                        } 
                    } else {
                        CCRZ.pubSub.trigger("pageMessage", CCRZ.createPageMessage('ERROR', "messagingSection-subsc-Error", CCRZ.processPageLabelMap('KFB2B_mySubsc_couldNotDownload').toString()));
                        window.scroll(0,0);
                        setTimeout(function(){
                            $('.messagingSection-subsc-Error').css('display', 'none');
                        }, 4000);
                        UTIL.hideLoader();
                    }
                },
                sortSubsc: function(v, res){
                    let _this = this;
                    _this.model.set("isActive", true);
                    _this.model.set("isInactive", true);
                    let subscriptionList = [], isSubsc = false;
                    if(res.data.subsDataList && res.data.subsDataList.length > 0){ 
                        let subscriptionListActive = res.data.subsDataList.filter(function(e){
                            return e.status == 'Active';
                        }); 
                        if(subscriptionListActive && subscriptionListActive.length){
                            for(let i = 0; i < subscriptionListActive.length; i++){
                                subscriptionList.push(subscriptionListActive[i]);
                                if(subscriptionListActive[i].productSptType != 'Reprint' && subscriptionListActive[i].status == 'Active'){
                                    isSubsc = true;
                                }
                            }
                        }  
                        let subscriptionListInActive = res.data.subsDataList.filter(function(e){
                            return e.status != 'Active';
                        }); 
                        if(subscriptionListInActive && subscriptionListInActive.length){
                            for(let i = 0; i < subscriptionListInActive.length; i++){
                                subscriptionList.push(subscriptionListInActive[i]);
                            }
                        } 
                    }
                    _this.model.set("subscriptionList", _.sortBy(subscriptionList, function(subsc) { return subsc.productName; }));
                    _this.model.set("imageList", res.data.imageList);
                    _this.model.set("layoutList", res.data.layoutList);
                    _this.model.set("colorList", res.data.colorList);
                    _this.model.set("langList", res.data.langList);
                    _this.model.set("accountData", res.data.account);
                    _this.model.set("isSubsc", isSubsc);
                    _this.model.set("filterSubscriptionList", _.sortBy(subscriptionList, function(subsc) { return subsc.productName; }));
                    _this.model.set("isInit", true);
                    CCRZ.subscBackUpModel = _this.model;
                    v.render(false);
                },
                filterSubscription: function(event){
                    let isActive = $('#active').is(":checked"), isInactive = $('#inactive').is(":checked"), activeValue =$('#active').val(), inactiveValue = $('#inactive').val();
                    if(!isActive && !isInactive){
                        $('#active').prop('checked', true);
                        $('#inactive').prop('checked', true);
                        isActive = true;
                        isInactive = true;
                    }
                    let filterSubscriptionList = this.model.attributes.subscriptionList.filter(function(e){
                        return ((isActive && isInactive)? (e.status == activeValue || e.status != activeValue): (isActive?e.status == activeValue: e.status != activeValue));
                    });   
                    this.model.set("filterSubscriptionList", filterSubscriptionList); 
                    this.model.set("isActive", isActive);    
                    this.model.set("isInactive", isInactive);  
                    this.model.set("isFilter", true);  
                    this.render(false);
                },
                closeModal: function(event){
                    this.model.set('isModal', false);
                    $('#actionPopUp').removeClass('in show');
                    $('.modal-backdrop').css("display", "none");
                    $('.modal-backdrop').removeClass('show');
                    $('.cc_main_body').removeClass('modal-open');
                    $('.cc_main_body').css("padding-right", "0px")
                    $('.cc_main_body').css('overflow','scroll');
                    $('#preferenceModal').modal('toggle');
                }
            });
            CCRZ.customSubscriptionView = new CCRZ.views.customSubscriptionView({
                model : new customSubscriptionModel()
            });
            return CCRZ.customSubscriptionView;
        }
    } 
});


